<template>
  <div class="admin-page">
    <div class="content">
      <h1>{{ isSignUp ? 'Sign Up' : 'Login' }}</h1>
      <span v-if="errorMessage" style="color: red;">{{ errorMessage }}</span>
      <form class="login-form" @submit.prevent="onSubmit">
        <AppControllerInput v-model="email" label="email" autocomplete="off"
          >Email</AppControllerInput
        >
        <AppControllerInput v-model="password" type="password" label="password"
          >Password</AppControllerInput
        >
        <div class="action-buttons">
          <AppButton type="button" @click="onCancel">Cancel</AppButton>
          <AppButton type="submit">Submit</AppButton>
          <AppButton
            type="button"
            class="switch-button"
            @click="isSignUp = !isSignUp"
            >Switch to {{ isSignUp ? 'Sign Up' : 'Login' }}</AppButton
          >
        </div>
      </form>
    </div>
  </div>
</template>

<script>
export default {
  layout: 'admin',
  data() {
    return {
      email: '',
      password: '',
      isSignUp: true,
      errorMessage: '',
    }
  },
  methods: {
    onSubmit() {
      // eslint-disable-next-line no-console
      console.log('Email = ', this.email, 'password = ', this.password)
      const user = {
        email: this.email,
        password: this.password,
        isSignUp: this.isSignUp,
      }
      this.$store.dispatch('auth/authenticate', user).then((result) => {
        if (result && result.isError) {
          // eslint-disable-next-line no-console
          console.log('Error reported', result)
          this.errorMessage = result.message
        } else {
          this.$router.push('/')
        }
      })
    },
    onCancel() {
      this.$router.push('/')
    },
  },
}
</script>
<style>
.admin-page {
  max-width: 800px;
  position: relative;
  background-color: #ddd;
  margin: 0 auto;
  margin-top: 4.25rem;
}
.content {
  width: 100%;
  margin: 10px 0;
  padding: 20px;
}
.switch-button {
  float: right;
  margin-right: 10%;
}
</style>
